local mod = ...



-- Job: Event Trigger -------------------------------------------------------------------------------------
mod:register({
    DataType = "JOB",
    Id = "JOB_SECURITY_EVENT_OUTLAW",
    JobName = "EVENT_SECURITY_OUTLAW_NAME",
    JobDescription = "EVENT_SECURITY_OUTLAW_DESC",
    IsLockedByDefault = true,
    Hidden = true,
    DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 0.0, -- default 30
    AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
    CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        IdleAnimation = "IDLE"
    }
})

mod:override({ Id = "NEWCOMER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_EVENT_OUTLAW" } })
mod:override({ Id = "SERF", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_EVENT_OUTLAW" } })
mod:override({ Id = "COMMONER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_EVENT_OUTLAW" } })
mod:override({ Id = "CITIZEN", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_EVENT_OUTLAW" } })

mod:register({
    DataType = "JOB",
    Id = "JOB_SECURITY_EVENT_OUTLAW_STOLE",
    JobName = "EVENT_SECURITY_OUTLAW_STOLE_NAME",
    JobDescription = "EVENT_SECURITY_OUTLAW_STOLE_DESC",
    IsLockedByDefault = true,
    Hidden = true,
    DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 0.0, -- default 30
    AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
    CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        IdleAnimation = "IDLE"
    }
})

mod:override({ Id = "NEWCOMER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_EVENT_OUTLAW_STOLE" } })
mod:override({ Id = "SERF", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_EVENT_OUTLAW_STOLE" } })
mod:override({ Id = "COMMONER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_EVENT_OUTLAW_STOLE" } })
mod:override({ Id = "CITIZEN", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_EVENT_OUTLAW_STOLE" } })



-- Quest ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "QUEST",
    Id = "QUEST_SECURITY_EVENT_OUTLAW",
    Name = "EVENT_SECURITY_OUTLAW_NAME",
    Description = "EVENT_SECURITY_OUTLAW_DESC",
    IsSilent = true,
    QuestFunction = {
        DataType = "QUEST_FUNCTION_ASSIGN_WORKER",
        Job = "JOB_SECURITY_EVENT_OUTLAW",
    },
    QuestRewardList = nil,
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil,
    OnSuccessCallback = {
        DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
        Event = "EVENT_SECURITY_OUTLAW"
    },
})

mod:register({
    DataType = "QUEST",
    Id = "QUEST_SECURITY_EVENT_OUTLAW_STOLE",
    Name = "EVENT_SECURITY_OUTLAW_STOLE_NAME",
    Description = "EVENT_SECURITY_OUTLAW_STOLE_DESC",
    IsSilent = true,
    QuestFunction = {
        DataType = "QUEST_FUNCTION_ASSIGN_WORKER",
        Job = "JOB_SECURITY_EVENT_OUTLAW_STOLE",
    },
    QuestRewardList = nil,
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil,
    OnSuccessCallback = {
        DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
        Event = "EVENT_SECURITY_OUTLAW_STOLE"
    },
})


-- Default Balancing (event list) ---------------------------------------------------------------------------------------------
mod:override({
    Id = "DEFAULT_BALANCING",
    EventList = {
        Action = "APPEND", 
        "EVENT_SECURITY_SETUP_OUTLAW",
        "EVENT_SECURITY_SETUP_OUTLAW_STOLE",
    },
})


-- Event: Setup Outlaw ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "EVENT",
    Id = "EVENT_SECURITY_SETUP_OUTLAW",
    Title = "EVENT_SECURITY_OUTLAW_NAME",
    Description = "EVENT_SECURITY_OUTLAW_DESC",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysToFirst = 1, -- number of days from the start of the game (setting = 5 will fire the event at the start of Day 5). 
    ConditionList = {
        {
            DataType = "EVENT_CONDITION_BUILDING_BUILT",
            AssetBuilding = "BUILDING_VILLAGE_CENTER"
        }
    },
    ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_SECURITY_EVENT_OUTLAW"
        },
    }
})

mod:register({
    DataType = "EVENT",
    Id = "EVENT_SECURITY_SETUP_OUTLAW_STOLE",
    Title = "EVENT_SECURITY_OUTLAW_NAME_STOLE",
    Description = "EVENT_SECURITY_OUTLAW_DESC_STOLE",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysToFirst = 1, -- number of days from the start of the game (setting = 5 will fire the event at the start of Day 5). 
    ConditionList = {
        {
            DataType = "EVENT_CONDITION_BUILDING_BUILT",
            AssetBuilding = "BUILDING_VILLAGE_CENTER"
        }
    },
    ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_SECURITY_EVENT_OUTLAW_STOLE"
        },
    }
})


-- Event: Outlaw ---------------------------------------------------------------------------------------------------------------
mod:register({
    DataType = "EVENT",
    Id = "EVENT_SECURITY_OUTLAW",
    Title = "EVENT_SECURITY_OUTLAW_NAME",
    Description = "EVENT_SECURITY_OUTLAW_DESC",
    IsInMainPool = false,
    IsRecurrent = true,
    DaysToFirst = 1,
    ConditionList = {
    },
    ActionList = {
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            AssetNotification = "NOTIFICATION_SECURITY_OUTLAW",
            NarrativePanelData = {
                DataType = "DATA_NARRATIVE_PANEL",
                Title = "EVENT_SECURITY_OUTLAW_NAME",
                Description = "EVENT_SECURITY_OUTLAW_DESC",
                PanelVisual = "ILLUSTRATION_EVENT_WAR",
            },
            ChoiceList = {
                {
                    DataType = "EVENT_CHOICE",
                    ShortName = "EVENT_SECURITY_OK",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_IGNORE"
                        },
                    },
                    OnClickCallbackList = nil
                },
            },
            OnClickCallback = nil
        },
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_SECURITY_EVENT_OUTLAW"
        },
    }
})

mod:register({
    DataType = "EVENT",
    Id = "EVENT_SECURITY_OUTLAW_STOLE",
    Title = "EVENT_SECURITY_OUTLAW_STOLE_NAME",
    Description = "EVENT_SECURITY_OUTLAW_STOLE_DESC",
    IsInMainPool = false,
    IsRecurrent = true,
    DaysToFirst = 1,
    ConditionList = {
    },
    ActionList = {
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            AssetNotification = "NOTIFICATION_SECURITY_OUTLAW_STOLE",
            NarrativePanelData = {
                DataType = "DATA_NARRATIVE_PANEL",
                Title = "EVENT_SECURITY_OUTLAW_STOLE_NAME",
                Description = "EVENT_SECURITY_OUTLAW_STOLE_DESC",
                PanelVisual = "ILLUSTRATION_EVENT_WAR",
            },
            ChoiceList = {
                {
                    DataType = "EVENT_CHOICE",
                    ShortName = "EVENT_SECURITY_OK",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_IGNORE"
                        },
                    },
                    OnClickCallbackList = nil
                },
            },
            OnClickCallback = nil
        },
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_SECURITY_EVENT_OUTLAW_STOLE"
        },
    }
})



-- Notification ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "NOTIFICATION",
    Id = "NOTIFICATION_SECURITY_OUTLAW",
    Title = "EVENT_SECURITY_OUTLAW_NAME",
    Description = "EVENT_SECURITY_OUTLAW_DESC",
    Severity = 1,
    DelayBeforeHide = 60,
})

mod:register({
    DataType = "NOTIFICATION",
    Id = "NOTIFICATION_SECURITY_OUTLAW_STOLE",
    Title = "EVENT_SECURITY_OUTLAW_STOLE_NAME",
    Description = "EVENT_SECURITY_OUTLAW_STOLE_DESC",
    Severity = 1,
    DelayBeforeHide = 30,
})

